!=========================================================================
! Copyright (C) GemStone Systems, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: bom.gs,v 1.11 2008-01-09 19:02:29 stever Exp $
!
! Description -  more initialization of the image
!   create UserGlobals dictionary for DataCurator
!   create UserGlobals dictionary for SystemUser
!   create various things in Globals and initialize various  class variables.
!
! Repository conversion - this file is NOT used. bomconv.gs is input by
!   this file. bomconv.gs is the subset used by GemStone conversion also.
!
!========================================================================

run
| symList newDict |
System currentSegment: DataCuratorSegment.

symList:= (AllUsers detect: [:x | x userId = 'DataCurator']) symbolList.
newDict := SymbolDictionary new .
newDict name: #UserGlobals ;
        at: #NativeLanguage put: #English.
symList insertObject: newDict at: 1.

symList:= (AllUsers detect: [:x | x userId = 'SystemUser']) symbolList.
newDict := SymbolDictionary new .
newDict name: #UserGlobals ;
        at: #NativeLanguage put: #English.
symList insertObject: newDict at: 1.

^ true
%

run
Segment _classVars at: #AuthorizationSymbols 
  put: #[ #none, #write, #read, #write ] .
^ true
%

! Create the default TimeZone object for filein. 
! The default is the US/Pacific Time.
! This will all be replaced by TimeZone2007.gs
!
run
Globals at: #'TimeZone' put: ObsoleteTimeZone.
true.
%
run
| cache aTimeZone |
aTimeZone := TimeZone 
	timeDifferenceHrs: -8 
	dstHrs: 1 
	atTimeHrs: 2
	fromDayNum: 73
	toDayNum: 311
	on: #Sunday 
	beginning: 1967
	stdPrintString: 'PST'
	dstPrintString: 'PDT'.

aTimeZone installAsCurrentTimeZone.
cache := SymbolDictionary new.
cache at: #'America/Los_Angeles' put: aTimeZone.
TimeZone _classVars 
	at: #Default put: aTimeZone;
	at: #TimeZones put: cache;
	yourself.
^ true.
%
commit

run

  "Define mapping from old class names to new class names. Used by
  the method Behavior>>convRecompileWith: to translate literal variable
  references."

  | convDict |
  convDict := SymbolDictionary new.
  convDict at: #HashDictionary put: #KeyValueDictionary;
           at: #IdentityHashDictionary put: #IdentityKeyValueDictionary;
           at: #IntegerHashDictionary put: #IntegerKeyValueDictionary;
           at: #StringHashDictionary put: #StringKeyValueDictionary;
           at: #SymbolHashDictionary put: #SymbolKeyValueDictionary;
           at: #RcHashDictionary put: #RcKeyValueDictionary;
           at: #RcBag put: #RcIdentityBag;
           at: #AbstractBag put: #UnorderedCollection;
           at: #SymbolListDictionary put: #SymbolDictionary;
           at: #Bag put: #IdentityBag;
           at: #Set put: #IdentitySet.

  "Note, the compiler will automatically translate  the following
      EmptyArray to #()
      EmptyString to '' ."

  Globals at: #ConversionDict put: convDict.
^ true
%

!define month and day names for various classes
input $upgradeDir/bomconv.gs

! initialize method dictionaries to empty for private classes
removeallmethods NscNode
removeallclassmethods NscNode
removeallmethods NscInteriorNode
removeallclassmethods NscInteriorNode
removeallmethods NscSetLeaf
removeallclassmethods NscSetLeaf
removeallmethods NscBagLeaf
removeallclassmethods NscBagLeaf
removeallmethods LargeObjectNode
removeallclassmethods LargeObjectNode

run
  " remove Associations of private classes from Globals"
Globals
        removeAssociation: (Globals associationAt: #NscNode);
        removeAssociation: (Globals associationAt: #NscInteriorNode);
        removeAssociation: (Globals associationAt: #NscSetLeaf);
        removeAssociation: (Globals associationAt: #NscBagLeaf);
"------------------------------------------------
DependencyList is now user visible
        removeAssociation: (Globals associationAt: #DependencyList);
-------------------------------------------------"
        removeAssociation: (Globals associationAt: #LargeObjectNode).
^ true
%

run
System currentSegment: DataCuratorSegment.
^ true
%

! ===================================================================
!   following was in bomnew32.opl in v3.2

! create instances of new class ClusterBucket
expectvalue 0
run
  "Expect SmallInteger 0"
^ AllClusterBuckets size
%

level 0
run
  "Cluster bucket 1"
  (ClusterBucket newForExtent: nil "extent is don't care") 
  description: 'Generic bucket 1. The default bucket after login.' ;
  immediateInvariant  "This bucket may not be changed".

  "Cluster bucket 2"
  (ClusterBucket newForExtent: nil "extent is don't care") 
  description: 'Generic bucket 2' .

  "Cluster bucket 3"
  (ClusterBucket newForExtent: nil "extent is don't care") 
  description: 'Generic bucket 3' .

  "Cluster bucket 4"
  (ClusterBucket newForExtent: 1 "primary extent") 
  description: 'Kernel classes behavior bucket' .

  "Cluster bucket 5"
  (ClusterBucket newForExtent: 1 "primary extent") 
  description: 'Kernel classes description bucket' .

  "Cluster bucket 6"
  (ClusterBucket newForExtent: 1 "primary extent")
  description: 'Kernel bucket for AllSymbols and other kernel objects' .

  "Cluster bucket 7"  
  "  provided so the maximum clusterId returns a generic bucket in the
     GemStone kernel for compatibility with prior releases"
  (ClusterBucket newForExtent: nil "extent is don't care")
  description: 'Generic bucket 7' .

^ AllClusterBuckets size == 7 "expect result == true "
%

!  now cluster AllClusterBuckets, which must be in the default cluster bucket
commit
expectvalue false
run
AllClusterBuckets clusterInBucket: 1.
%
commit

method: Class
instVar: aSymbol put: aValue
self _unsafeAt: (self class _ivOffsetOf: aSymbol) put: aValue
%

run
| classes epoch |

System currentSegment: SystemSegment .

epoch :=  DateTime now  .

classes := Globals select: [ :aValue| aValue isKindOfClass: Class ] .

classes associationsDo:[:i | | aClass |
  aClass := i value .
  aClass description: nil .
  aClass instVar: #timeStamp put: epoch .
  aClass instVar: #userId put: 'SystemUser'.
  aClass instVar: #extraDict put: (SymbolDictionary new) .
     "ClassHistory initialized by bom.c / repository conversion "
     "migrationDestination instance variable left as nil " 
  ].
^ true
%
run
Class removeSelector: #instVar:put: ifAbsent:[ nil ] .
^ true
%

! object 3625 (v4.1 OOP 906) (conversion status) already created in bom.c
! end bomnew32.opl stuff
!===============================================================
