!=========================================================================
! Copyright (C) GemStone Systems, Inc. 1986-2011.  All Rights Reserved.
!
! $Id: bomnew.gs,v 1.7 2008-01-09 19:02:29 stever Exp $
!
! Description - Create reserved objects from Smalltalk, that are 
!   newly created in version 4.0 .  These are objects that may be created
!   directly in the target repository, if in repository conversion.
! 
! Repository conversion uses this file.
!
!=========================================================================


! initialize some class categories  for the benefit of Geode methods
run
Object category: 'Kernel'.
Number category: 'Numbers'.
Collection category: 'Collections'.
Behavior category: 'Classes'.
ClassHistory category: 'Classes'.
^ true
%

!   Make SymbolList take either a SymbolDictionary
!   or a ObsoleteSymbolDictionary
!     As of 5.0, this patch deleted


! #_incompletePathTraversal now a canonical symbol
! This object signifies that a path could not be traversed to the end.
expectvalue %String
run
Globals removeKey: #_incompletePathTraversal ifAbsent:[ ^ 'not found' ] .
^ 'removed'
%

! install the method required for kernel class creation of classes with
! reserved OOPs
!
category: 'Repository Conversion'
method: Object
_unsafeSetOop: aPositiveInteger

  "aPositiveInteger must be the integer value of a 5.0 OopType" 

  <primitive: 385>
  ^ self _primitiveFailed: #_unsafeSetOop:
%
commit
